/* Intel Core2 gmp-mparam.h -- Compiler/machine parameter header file.

Copyright 1991, 1993, 1994, 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007
Free Software Foundation, Inc.

This file is part of the GNU MP Library.

The GNU MP Library is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 3 of the License, or (at your
option) any later version.

The GNU MP Library is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
License for more details.

You should have received a copy of the GNU Lesser General Public License
along with the GNU MP Library.  If not, see http://www.gnu.org/licenses/.  */

#define BITS_PER_MP_LIMB 64
#define BYTES_PER_MP_LIMB 8

/* 2133 MHz Conroe */

/* Generated by tuneup.c, 2007-09-01, gcc 3.4 */

#define MUL_KARATSUBA_THRESHOLD          46
#define MUL_TOOM3_THRESHOLD             144

#define SQR_BASECASE_THRESHOLD           17
#define SQR_KARATSUBA_THRESHOLD         106
#define SQR_TOOM3_THRESHOLD             164

#define MULLOW_BASECASE_THRESHOLD         0  /* always */
#define MULLOW_DC_THRESHOLD             176
#define MULLOW_MUL_N_THRESHOLD         1446

#define DIV_SB_PREINV_THRESHOLD           0  /* always */
#define DIV_DC_THRESHOLD                104
#define POWM_THRESHOLD                  185

#define GCD_ACCEL_THRESHOLD               3
#define GCDEXT_THRESHOLD                 27
#define JACOBI_BASE_METHOD                1

#define DIVREM_1_NORM_THRESHOLD           0  /* always */
#define DIVREM_1_UNNORM_THRESHOLD         0  /* always */
#define MOD_1_NORM_THRESHOLD              0  /* always */
#define MOD_1_UNNORM_THRESHOLD            0  /* always */
#define USE_PREINV_DIVREM_1               1
#define USE_PREINV_MOD_1                  1
#define DIVREM_2_THRESHOLD                0  /* always */
#define DIVEXACT_1_THRESHOLD              0  /* always */
#define MODEXACT_1_ODD_THRESHOLD          0  /* always (native) */

#define GET_STR_DC_THRESHOLD             13
#define GET_STR_PRECOMPUTE_THRESHOLD     20
#define SET_STR_THRESHOLD             29473

#define MUL_FFT_TABLE  { 368, 864, 2112, 3840, 7168, 20480, 81920, 327680, 786432, 3145728, 12582912, 0 }
#define MUL_FFT_MODF_THRESHOLD          432
#define MUL_FFT_THRESHOLD              4608

#define SQR_FFT_TABLE  { 528, 1056, 2368, 3840, 11264, 28672, 81920, 196608, 786432, 3145728, 12582912, 0 }
#define SQR_FFT_MODF_THRESHOLD          472
#define SQR_FFT_THRESHOLD              3968
